addHook("MobjThinker", function(m)
	if stoppedclock == true
	and gamemap == 462
		if m.state == S_BUMPER
		or m.state == S_BUMPERHIT
			A_PlaySound(m, sfx_pop, 0)
			m.state = S_XPLD1
		end
	end
end, MT_BUMPER)//it won't work out so well if it just checks for m.type == MT_BUMPER
addHook("MobjThinker", function(m)
	if gamemap == 468
		if P_RandomRange(1, 255) == 1
			S_StartSound(m, sfx_cdfm34)
			P_SpawnMobjFromMobj(m, 0, 0, 0, MT_SUPERSPARK)
		end
	end
end, MT_TUBEWAYPOINT)
addHook("PlayerSpawn", function(p)
	if gamemap == 468
	and ultimatemode == false
	and leveltime < 35
		if p.powers[3] ~= 512
			P_SwitchShield(p, 257)
		elseif p.powers[3] == 512
			P_SwitchShield(p, 769)
		end
	end
end)
addHook("MapLoad", function(gamemap)
	if gamemap == 468
		states[S_SSPK1].sprite = SPR_SHCK
		states[S_SSPK2].sprite = SPR_SHCK
		states[S_SSPK3].sprite = SPR_SHCK
		states[S_SSPK4].sprite = SPR_SHCK
		states[S_SSPK5].sprite = SPR_SHCK
	else
		states[S_SSPK1].sprite = SPR_SSPK
		states[S_SSPK2].sprite = SPR_SSPK
		states[S_SSPK3].sprite = SPR_SSPK
		states[S_SSPK4].sprite = SPR_SSPK
		states[S_SSPK5].sprite = SPR_SSPK
	end
end)//makes the water in KSZ3 appear to be electrified so that players don't decide to jump into it
addHook("PlayerSpawn", function(p)
	if gamemap == 474
	and multiplayer == false
	and (p.mo.skin == "fang" or p.mo.skin == "amy")
		states[S_FBOMB_EXPL6].nextstate = S_NULL
	elseif gamemap == 474
		states[S_FBOMB_EXPL6].nextstate = S_FBOMB_EXPL7
	end
end)
addHook("MobjSpawn", function(m)
	if gamemap == 474
	and multiplayer == false
	and (players[0].mo.skin == "fang" or players[0].mo.skin == "amy")
		m.fuse = 1050
	end
end, MT_BUMBLEBORE)
addHook("MobjFuse", function(m)
	if gamemap == 474
	and multiplayer == false
	and (players[0].mo.skin == "fang" or players[0].mo.skin == "amy")
		P_RemoveMobj(m)
	end
end, MT_BUMBLEBORE)
addHook("MapLoad", function(gamemap)
	if ultimatemode == true
	and gamemap == 474
		mobjinfo[MT_BUMBLEBORE].speed = 2*FRACUNIT
	else
		mobjinfo[MT_BUMBLEBORE].speed = 4*FRACUNIT
	end
end)
addHook("MobjSpawn", function(m)
	if gamemap == 478
		m.health = 16
		m.info.damage = 11
	else
		m.info.damage = 3
	end
end, MT_EGGMOBILE3)
addHook("ShouldDamage", function(t, i, s, d, dt)
	if i.type == MT_DRAGONMINE
		return false
	end
end, MT_EGGMOBILE3)
addHook("ShouldDamage", function(t, i, s, d, dt)
	if i.type == MT_DRAGONMINE
		return false
	end
end, MT_CYBRAKDEMON)
addHook("ShouldDamage", function(t, i, s, d, dt)
	if gamemap == 481
	and i == nil
		return false
	end
end, MT_DRAGONBOMBER)//prevents the dragonbomber add in BKZ3 from killing itself on the lasers
addHook("ShouldDamage", function(t, i, s, d, dt)
	if gamemap == 481
	and i == nil
		return false
	end
end, MT_DRAGONMINE)//prevents the dragonbomber mines in BKZ3 from getting blown up by the lasers
addHook("MobjSpawn", function(m)
	if gamemap == 481
		mobjinfo[MT_DRAGONBOMBER].speed = 15*FRACUNIT
		m.colorized = (m.health > 0)
		m.color = SKINCOLOR_MASTER
	else
		mobjinfo[MT_DRAGONBOMBER].speed = 10*FRACUNIT
	end
end, MT_DRAGONBOMBER)
addHook("MobjSpawn", function(m)
	if gamemap == 481
		m.color = SKINCOLOR_MASTER
		m.colorized = (m.health > 0)
	end
end, MT_DRAGONTAIL)
addHook("PlayerSpawn", function(p)
	if gamemap == 462//GFZ3
	and leveltime >= 35
		P_SetOrigin(p.mo, 2848*FRACUNIT, 2912*FRACUNIT, 800*FRACUNIT)
	end
	if gamemap == 465//THZ3
	and leveltime >= 35
		P_SetOrigin(p.mo, 0, 0, 800*FRACUNIT)
	end
	if gamemap == 468//DSZ3
	and leveltime >= 35
		P_SetOrigin(p.mo, 1696*FRACUNIT, 128*FRACUNIT, 800*FRACUNIT)
	end
	if gamemap == 471//CEZ3
	and leveltime >= 35
		P_SetOrigin(p.mo, 1760*FRACUNIT, 2304*FRACUNIT, 800*FRACUNIT)
	end
	if gamemap == 474//ACZ3
	and leveltime >= 35
		P_SetOrigin(p.mo, 0, 0, 800*FRACUNIT)
	end
	if gamemap == 478//ERZ3
	and leveltime >= 35
		P_SetOrigin(p.mo, 448*FRACUNIT, 6016*FRACUNIT, 800*FRACUNIT)
	end
	if gamemap == 480//BCZ2
	and leveltime >= 35
		P_SetOrigin(p.mo, 0, 0, 800*FRACUNIT)
	end
	if gamemap == 481//BCZ3
	and leveltime >= 35
		P_SetOrigin(p.mo, 5600*FRACUNIT, 3072*FRACUNIT, 800*FRACUNIT)
	end
end)//this hook prevents you from respawning during this mod's boss fights in netgames, and from spawning mid-way through the boss fight, by sticking you into a reset chamber